Index: trunk/src/org/expeditee/gui/FrameGraphics.java
===================================================================
--- trunk/src/org/expeditee/gui/FrameGraphics.java	(revision 1414)
+++ trunk/src/org/expeditee/gui/FrameGraphics.java	(revision 1415)
@@ -141,5 +141,5 @@
 		EcosystemManager.getGraphicsManager().clear(backgroundColor);
 
-		List<Item> visibleItems = new LinkedList<Item>();
+		List<Item> itemsToPaintCanditates = new LinkedList<Item>();
 		List<Widget> paintWidgets;
 
@@ -147,10 +147,10 @@
 			// Add all the items for this frame and any other from other
 			// frames
-			visibleItems.addAll(toPaint.getAllItems());
+			itemsToPaintCanditates.addAll(toPaint.getAllItems());
 			paintWidgets = toPaint.getAllOverlayWidgets();
 			paintWidgets.addAll(toPaint.getInteractiveWidgets());
 		} else {
-			visibleItems.addAll(toPaint.getVisibleItems());
-			visibleItems.addAll(toPaint.getVectorItems());
+			itemsToPaintCanditates.addAll(toPaint.getVisibleItems());
+			itemsToPaintCanditates.addAll(toPaint.getVectorItems());
 			paintWidgets = toPaint.getInteractiveWidgets();
 		}
@@ -181,9 +181,9 @@
 
 		if (clip == null) {
-			paintItems = visibleItems;
+			paintItems = itemsToPaintCanditates;
 		} else {
 			fillOnlyItems = new HashSet<Item>();
 			paintItems = new LinkedList<Item>();
-			for (Item i : visibleItems) {
+			for (Item i : itemsToPaintCanditates) {
 				if (clip == null || i.isInDrawingArea(clip.getBounds())) {
 					paintItems.add(i);
@@ -201,5 +201,5 @@
 		// Only paint files and lines once ... between anchored AND free items
 		PaintPictures(paintItems, fillOnlyItems, paintedFillsAndLines);
-		PaintLines(visibleItems);
+		PaintLines(itemsToPaintCanditates);
 
 
@@ -380,4 +380,5 @@
 
 		List<Item> toFill = new LinkedList<Item>();
+		
 		for (Item i : toPaint) {
 			// Ignore items that have already been done!
Index: trunk/src/org/expeditee/gui/FrameIO.java
===================================================================
--- trunk/src/org/expeditee/gui/FrameIO.java	(revision 1414)
+++ trunk/src/org/expeditee/gui/FrameIO.java	(revision 1415)
@@ -88,5 +88,4 @@
  */
 
-
 public class FrameIO {
 
@@ -214,81 +213,4 @@
 	}
 	
-//	public static void changeParentAndSubFolders(String newFolder) {
-//		// Partial Paths.
-//		PARENT_FOLDER = newFolder;	
-//		String resourcesPublicPath = PARENT_FOLDER + "resources-public" + File.separator;
-//		String resourcesPrivateIndividualPath = PARENT_FOLDER + "resources-" + UserSettings.UserName.get() + File.separator;
-//
-//		// Standard paths.
-//		PUBLIC_PATH = PARENT_FOLDER + "public" + File.separator;
-//		TRASH_PATH = PARENT_FOLDER + "trash" + File.separator;
-//		HELP_PATH = PARENT_FOLDER + "documentation" + File.separator;
-//		PROFILE_PATH = PARENT_FOLDER + "profiles" + File.separator;
-//		EXPORTS_PATH = PARENT_FOLDER + "exports" + File.separator;
-//		STATISTICS_PATH = PARENT_FOLDER + "statistics" + File.separator;
-//		LOGS_PATH = PARENT_FOLDER + "logs" + File.separator;
-//				
-//		
-//		// Conditional paths
-//		if (UserSettings.PublicAndPrivateResources) {
-//			// Work with a system of public and private folders
-//			
-//			FONT_PATH = resourcesPublicPath + "fonts" + File.separator;
-//			DICT_PATH = resourcesPublicPath + "dict" + File.separator;
-//			IMAGES_PATH = resourcesPublicPath + "images" + File.separator;
-//			AUDIO_PATH = resourcesPublicPath + "audio" + File.separator;
-//			FRAME_PATH = resourcesPublicPath + "framesets" + File.separator;
-//		} else {
-//			FONT_PATH = PARENT_FOLDER + "fonts" + File.separator;
-//			DICT_PATH = PARENT_FOLDER + "dict" + File.separator;
-//			IMAGES_PATH = PARENT_FOLDER + "images" + File.separator;
-//			AUDIO_PATH = PARENT_FOLDER + "audio" + File.separator;
-//			FRAME_PATH = PARENT_FOLDER + "framesets" + File.separator;
-//			DEAD_DROPS_PATH = PARENT_FOLDER + "deaddrops" + File.separator;
-//		}
-//		
-//		if (!UserSettings.PublicAndPrivateResources || (AuthenticatorBrowser.isAuthenticationRequired() && !AuthenticatorBrowser.isAuthenticated())) {
-//			
-//			if (UserSettings.UserName.get().equals(AuthenticatorBrowser.USER_NOBODY)) {
-//				System.err.println("**** FrameIO::changeParentAndSubFolders(): Not setting subfolders for user '"+AuthenticatorBrowser.USER_NOBODY+"'");
-//			}
-//			
-//			// If we are using the old regime, or user.name set to Browser.USER_NOBODY
-//			// => then these paths should not be used.
-//			RESOURCES_PATH = null;
-//			SHARED_FRAMESETS_PATH = null;
-//			RESOURCES_PRIVATE_PATH = null;		
-//			FRAME_PRIVATE_PATH = null;
-//			IMAGES_PRIVATE_PATH = null;
-//			AUDIO_PRIVATE_PATH = null;
-//			CONTACTS_PATH = null;
-//			HELP_PRIVATE_PATH = null;
-//			
-//			if (!UserSettings.PublicAndPrivateResources) {
-//				MESSAGES_PATH = PARENT_FOLDER + "messages" + File.separator;
-//			} else {
-//				MESSAGES_PATH = resourcesPrivateIndividualPath + "messages" + File.separator;
-//			}
-//			
-//		} else {
-//			RESOURCES_PATH = resourcesPublicPath + "documentation" + File.separator;
-//			SHARED_FRAMESETS_PATH = resourcesPrivateIndividualPath + "framesets-shared" + File.separator;
-//			
-//			RESOURCES_PRIVATE_PATH = PARENT_FOLDER + "resources-private" + File.separator;
-//			FRAME_PRIVATE_PATH = resourcesPrivateIndividualPath + "framesets" + File.separator;
-//			IMAGES_PRIVATE_PATH = resourcesPrivateIndividualPath + "images" + File.separator;
-//			AUDIO_PRIVATE_PATH = resourcesPrivateIndividualPath + "audio" + File.separator;
-//			CONTACTS_PATH = resourcesPrivateIndividualPath + "contacts" + File.separator;
-//			HELP_PRIVATE_PATH = resourcesPrivateIndividualPath + "documentation" + File.separator;
-//			MESSAGES_PATH = resourcesPrivateIndividualPath + "messages" + File.separator;
-//			MAIL_PATH = resourcesPrivateIndividualPath + "mail" + File.separator;
-//			DEAD_DROPS_PATH = resourcesPrivateIndividualPath + "deaddrops" + File.separator;
-//		} 
-//			
-//		
-//		System.err.println("**** FrameIO::changeParentAndSubFolder(): Calling AudioPathManger.changeParentAndSubFolder()");
-//		AudioPathManager.changeParentAndSubFolders(newFolder);
-//	}
-	
 	// All methods are static, this should not be instantiated
 	private FrameIO() {
@@ -1001,5 +923,5 @@
 		template.resetDateCreated();
 
-		for (Item i : template.getItems()) {
+		for (Item i : template.getSortedItems()) {
 			if (ItemUtils.startsWithTag(i, ItemUtils.TAG_PARENT)) {
 				i.setLink(null);
@@ -1009,6 +931,10 @@
 		// do auto shrinking of the title IF not in twin frames mode and the title is not centred
 		Item titleItem = template.getTitleItem();
-
-		if (!DisplayController.isTwinFramesOn() && !Justification.center.equals(((Text)titleItem).getJustification())) {
+		if (titleItem == null) {
+			return template; 
+		}
+		
+		boolean titleItemJustified = titleItem == null || !Justification.center.equals(((Text)titleItem).getJustification());
+		if (!DisplayController.isTwinFramesOn() && titleItemJustified) {
 			if ((titleItem.getX() + 1) < template.getNameItem().getX()) {
 				int title_item_xr = titleItem.getX() + titleItem.getBoundsWidth(); // should really be '... -1'
@@ -1307,5 +1233,5 @@
 				EcosystemManager.getMiscManager().beep();
 			} else if (checkBackup
-					&& ItemUtils.ContainsExactTag(toSave.getItems(),
+					&& ItemUtils.ContainsExactTag(toSave.getSortedItems(),
 							ItemUtils.TAG_BACKUP)) {
 				SuspendCache();
@@ -1338,5 +1264,5 @@
 				}
 
-				Item i = ItemUtils.FindExactTag(toSave.getItems(),
+				Item i = ItemUtils.FindExactTag(toSave.getSortedItems(),
 						ItemUtils.TAG_BACKUP);
 				i.setLink(original.getName());
@@ -1480,5 +1406,5 @@
 	}
 
-	public static Frame CreateNewProfile(String username, Map<String, Setting> initialSettings, Map<String, Consumer<Frame>> toNotifyOnSet) throws InvalidFramesetNameException, ExistingFramesetException  {
+	public static Frame CreateNewProfile(String username, Map<String, Setting> initialSettings, Map<String, Consumer<Frame>> toNotifyOnSet) throws InvalidFramesetNameException, ExistingFramesetException {
 		Frame profile = CreateFrameset(username, PROFILE_PATH, true);
 		if (profile != null) {
@@ -2110,4 +2036,11 @@
 	}
 	
+	public static boolean personalResourcesExist(String username) {
+		Path personalResources = Paths.get(FrameIO.PARENT_FOLDER).resolve("resources-" + username);
+		File personalResourcesFile = personalResources.toFile();
+		boolean directoryExists = personalResourcesFile.exists() && personalResourcesFile.isDirectory();
+		return directoryExists;
+	}
+	
 	public static Path setupPersonalResources(String username) {
 		Path personalResources = Paths.get(FrameIO.PARENT_FOLDER).resolve("resources-" + username);
Index: trunk/src/org/expeditee/gui/FrameUtils.java
===================================================================
--- trunk/src/org/expeditee/gui/FrameUtils.java	(revision 1414)
+++ trunk/src/org/expeditee/gui/FrameUtils.java	(revision 1415)
@@ -60,4 +60,5 @@
 import org.expeditee.core.bounds.AxisAlignedBoxBounds;
 import org.expeditee.core.bounds.PolygonBounds;
+import org.expeditee.encryption.items.surrogates.Label;
 import org.expeditee.gio.EcosystemManager;
 import org.expeditee.gio.gesture.StandardGestureActions;
@@ -384,5 +385,5 @@
 		}
 
-		for (Item i : current.getItems()) {
+		for (Item i : current.getSortedItems()) {
 			i.setHighlightMode(Item.HighlightMode.None);
 			i.setHighlightColorToDefault();
@@ -642,5 +643,5 @@
 	 * @return True if the image was created successfully, false otherwise
 	 */
-	private static boolean createPicture(Frame frame, Text txt) {
+	private static boolean createPicture(Frame frame, Text txt, ItemsList items) {
 		// attempt to create the picture
 		Picture pic = ItemUtils.CreatePicture(txt);
@@ -659,7 +660,11 @@
 			return false;
 		}
-		frame.addItem(pic);
+		frame.addItem(pic, true, items);
 
 		return true;
+	}
+	
+	private static boolean createPictureInBody(Frame frame, Text txt) {
+		return createPicture(frame, txt, frame.getBody());
 	}
 
@@ -678,5 +683,5 @@
 	 * @author Brook Novak
 	 */
-	private static boolean createWidget(Frame frame, Text txt) {
+	private static boolean createWidget(Frame frame, Text txt, ItemsList list) {
 
 		if (frame == null) {
@@ -713,9 +718,13 @@
 		}
 
-		frame.removeItem(txt);
-
-		frame.addAllItems(iw.getItems());
+		frame.removeItem(txt, true, list);
+
+		frame.addAllItems(iw.getItems(), list);
 
 		return true;
+	}
+	
+	private static boolean createWidgetInBody(Frame frame, Text txt) {
+		return createWidget(frame, txt, frame.getBody());
 	}
 
@@ -857,40 +866,9 @@
 		return dirsToAdd;
 	}
-
-	public static void Parse(Frame toParse) {
-		Parse(toParse, false);
-	}
-
-	/**
-	 * Checks for any special Annotation items and updates the display as necessary.
-	 * Special Items: Images, overlays, sort.
-	 * 
-	 */
-	public static void Parse(Frame toParse, boolean firstParse) {
-		Parse(toParse, firstParse, false);
-	}
-
-	/**
-	 * 
-	 * @param toParse
-	 * @param firstParse
-	 * @param ignoreAnnotations
-	 *            used to prevent infinate loops such as when performing TDFC with
-	 *            an ao tag linked to a frame with an frameImage of a frame which
-	 *            also has an ao tag on it.
-	 */
-	public static void Parse(Frame toParse, boolean firstParse, boolean ignoreAnnotations) {
-		// TODO check why we are getting toParse == null... when profile frame
-		// is being created and change the lines below
-		if (toParse == null) {
-			return;
-		}
-
-		if (firstParse) {
-			ItemUtils.EnclosedCheck(toParse.getItems());
-		}
-
-		List<Item> items = toParse.getItems();
-
+	
+	private static void transformOutOfPlaceItems(Frame toParse, ItemsList toTransform) {
+		// Get all items from toTransform that have not been marked as deleted.
+		List<Item> items = toParse.getItems(false, toTransform);
+		
 		// if XRayMode is on, replace pictures with their underlying text
 		if (DisplayController.isXRayMode()) {
@@ -901,5 +879,5 @@
 			for (Item i : items) {
 				if (i instanceof XRayable) {
-					toParse.removeItem(i);
+					toParse.removeItem(i, true, toTransform);
 					// Show the items
 					for (Item item : ((XRayable) i).getConnected()) {
@@ -908,7 +886,7 @@
 					}
 				} else if (i instanceof WidgetCorner) {
-					toParse.removeItem(i);
+					toParse.removeItem(i, true, toTransform);
 				} else if (i instanceof WidgetEdge) {
-					toParse.removeItem(i);
+					toParse.removeItem(i, true, toTransform);
 				} else if (i.hasFormula()) {
 					i.setText(i.getFormula());
@@ -920,13 +898,8 @@
 
 			for (Widget iw : widgets) {
-				toParse.addItem(iw.getSource());
-			}
-		}
-
-		// Text title = null;
-		// Text template = UserSettingsTemplate.copy();
-
-		List<Overlay> overlays = new ArrayList<Overlay>();
-		List<Vector> vectors = new ArrayList<Vector>();
+				toParse.addItem(iw.getSource(), true, toTransform);
+			}
+		}
+
 
 		// disable reading of cached overlays if in twinframes mode
@@ -935,16 +908,10 @@
 		}
 
-		// DotType pointtype = DotType.square;
-		// boolean filledPoints = true;
-
-		UserAppliedPermission permission = toParse.getUserAppliedPermission();
 		toParse.clearAnnotations();
 
 		// check for any new overlay items
-		for (Item i : toParse.getItems()) {
+		items = toParse.getItems(false, toTransform);
+		for (Item i : items) {
 			try {
-				// reset overlay permission
-				i.setOverlayPermission(null);
-				// i.setPermission(permission);
 				if (i instanceof WidgetCorner) {
 					// TODO improve efficiency so it only updates once... using
@@ -952,29 +919,105 @@
 					i.update();
 				} else if (i instanceof Text) {
+					if (!DisplayController.isXRayMode() && i.isAnnotation()) {
+						if (ItemUtils.startsWithTag(i, ItemUtils.TAG_IMAGE, true)) {
+							if (!i.hasEnclosures()) {
+								createPicture(toParse, (Text) i, toTransform);
+							}
+							// check for frame images
+						} else if (ItemUtils.startsWithTag(i, ItemUtils.TAG_FRAME_IMAGE) && i.getLink() != null
+								&& !i.getAbsoluteLink().equalsIgnoreCase(toParse.getName())) {
+							XRayable image = null;
+							if (i.hasEnclosures()) {
+								// i.setHidden(true);
+								// image =
+								// i.getEnclosures().iterator().next();
+								// image.refresh();
+							} else {
+								image = new FrameImage((Text) i, null);
+							}
+							// TODO Add the image when creating new
+							// FrameImage
+							toParse.addItem(image, true, toTransform);
+						} else if (ItemUtils.startsWithTag(i, ItemUtils.TAG_BITMAP_IMAGE) && i.getLink() != null
+								&& !i.getAbsoluteLink().equalsIgnoreCase(toParse.getName())) {
+							XRayable image = null;
+							if (i.hasEnclosures()) {
+								// image =
+								// i.getEnclosures().iterator().next();
+								// image.refresh();
+								// i.setHidden(true);
+							} else {
+								// If a new bitmap is created for a
+								// frame which already has a bitmap dont
+								// recreate the bitmap
+								image = new FrameBitmap((Text) i, null);
+							}
+							toParse.addItem(image, true, toTransform);
+						} else if (ItemUtils.startsWithTag(i, "@c")) {
+							// Can only have a @c
+							if (!i.hasEnclosures() && i.getLines().size() == 1) {
+								Circle circle = new Circle((Text) i);
+								toParse.addItem(circle, true, toTransform);
+							}
+							// Check for JSItem
+						} else if (ItemUtils.startsWithTag(i, "@js")) {
+							JSItem jsItem = new JSItem((Text) i);
+							toParse.addItem(jsItem, true, toTransform);
+							// Check for interactive widgets
+						} else if (ItemUtils.startsWithTag(i, ItemUtils.TAG_IWIDGET)) {
+							createWidget(toParse, (Text) i, toTransform);
+						}
+
+						// TODO decide exactly what to do here!!
+						toParse.addAnnotation((Text) i);
+					} else if (!DisplayController.isXRayMode() && i.hasFormula()) {
+						i.calculate(i.getFormula());
+					}
+				}
+			} catch (Exception e) {
+				Logger.Log(e);
+				e.printStackTrace();
+				System.err
+						.println("**** Have temporarily supressed MessageBay call, as resulted in infinite recursion");
+				// MessageBay.warningMessage("Exception occured when loading " +
+				// i.getClass().getSimpleName() + "(ID: "
+				// + i.getID() + ") " + e.getMessage() != null ? e.getMessage() : "");
+			}
+		}
+
+		/*
+		 * for (Item i : items) { if (i instanceof Dot) { ((Dot)
+		 * i).setPointType(pointtype); ((Dot) i).useFilledPoints(filledPoints); } }
+		 */
+
+		if (DisplayController.isTwinFramesOn()) {
+			FrameIO.ResumeCache();
+		}
+
+
+	}
+	
+	private static void generatingSupportingItems(Frame toParse, 
+			ItemsList toBuildOff, boolean ignoreAnnotations) {
+		// Get all items from toBuildOff that have not been marked as deleted.
+		List<Item> items = toParse.getItems(false, toBuildOff);
+
+		List<Overlay> overlays = new ArrayList<Overlay>();
+		List<Vector> vectors = new ArrayList<Vector>();
+
+		// disable reading of cached overlays if in twinframes mode
+		if (DisplayController.isTwinFramesOn()) {
+			FrameIO.SuspendCache();
+		}
+
+		UserAppliedPermission permission = toParse.getUserAppliedPermission();
+		// check for any new overlay items
+		for (Item i : items) {
+			try {
+				// reset overlay permission
+				i.setOverlayPermission(null);
+				if (i instanceof Text) {
 					if (i.isAnnotation()) {
-						if (ItemUtils.startsWithTag(i, ItemUtils.TAG_POINTTYPE)) {
-							Text txt = (Text) i;
-							String line = txt.getFirstLine();
-							line = ItemUtils.StripTag(line, ItemUtils.GetTag(ItemUtils.TAG_POINTTYPE));
-
-							if (line != null) {
-								line = line.toLowerCase();
-								if (line.indexOf(" ") > 0) {
-									String fill = line.substring(line.indexOf(" ") + 1);
-									if (fill.startsWith("nofill")) {
-										// filledPoints = false;
-									} else {
-										// filledPoints = true;
-									}
-								}
-
-								if (line.startsWith("circle")) {
-									// pointtype = DotType.circle;
-								} else {
-									// pointtype = DotType.square;
-								}
-							}
-						} // check for new VECTOR items
-						else if (!DisplayController.isXRayMode() && ItemUtils.startsWithTag(i, ItemUtils.TAG_VECTOR)
+						if (!DisplayController.isXRayMode() && ItemUtils.startsWithTag(i, ItemUtils.TAG_VECTOR)
 								&& i.getLink() != null) {
 							if (!i.getAbsoluteLink().equals(toParse.getName())) {
@@ -1047,59 +1090,5 @@
 							}
 						}
-						// check for Images and widgets
-						else {
-							if (!DisplayController.isXRayMode()) {
-								if (ItemUtils.startsWithTag(i, ItemUtils.TAG_IMAGE, true)) {
-									if (!i.hasEnclosures()) {
-										createPicture(toParse, (Text) i);
-									}
-									// check for frame images
-								} else if (ItemUtils.startsWithTag(i, ItemUtils.TAG_FRAME_IMAGE) && i.getLink() != null
-										&& !i.getAbsoluteLink().equalsIgnoreCase(toParse.getName())) {
-									XRayable image = null;
-									if (i.hasEnclosures()) {
-										// i.setHidden(true);
-										// image =
-										// i.getEnclosures().iterator().next();
-										// image.refresh();
-									} else {
-										image = new FrameImage((Text) i, null);
-									}
-									// TODO Add the image when creating new
-									// FrameImage
-									toParse.addItem(image);
-								} else if (ItemUtils.startsWithTag(i, ItemUtils.TAG_BITMAP_IMAGE) && i.getLink() != null
-										&& !i.getAbsoluteLink().equalsIgnoreCase(toParse.getName())) {
-									XRayable image = null;
-									if (i.hasEnclosures()) {
-										// image =
-										// i.getEnclosures().iterator().next();
-										// image.refresh();
-										// i.setHidden(true);
-									} else {
-										// If a new bitmap is created for a
-										// frame which already has a bitmap dont
-										// recreate the bitmap
-										image = new FrameBitmap((Text) i, null);
-									}
-									toParse.addItem(image);
-								} else if (ItemUtils.startsWithTag(i, "@c")) {
-									// Can only have a @c
-									if (!i.hasEnclosures() && i.getLines().size() == 1) {
-										toParse.addItem(new Circle((Text) i));
-									}
-									// Check for JSItem
-								} else if (ItemUtils.startsWithTag(i, "@js")) {
-									toParse.addItem(new JSItem((Text) i));
-									// Check for interactive widgets
-								} else if (ItemUtils.startsWithTag(i, ItemUtils.TAG_IWIDGET)) {
-									createWidget(toParse, (Text) i);
-								}
-							}
-							// TODO decide exactly what to do here!!
-							toParse.addAnnotation((Text) i);
-						}
-					} else if (!DisplayController.isXRayMode() && i.hasFormula()) {
-						i.calculate(i.getFormula());
+						
 					}
 				}
@@ -1118,5 +1107,7 @@
 		 */
 
-		FrameIO.ResumeCache();
+		if (DisplayController.isTwinFramesOn()) {
+			FrameIO.ResumeCache();
+		}
 
 		toParse.clearOverlays();
@@ -1124,5 +1115,63 @@
 		toParse.addAllOverlays(overlays);
 		toParse.addAllVectors(vectors);
-
+	}
+
+	public static void Parse(Frame toParse) {
+		Parse(toParse, false);
+	}
+
+	/**
+	 * Checks for any special Annotation items and updates the display as necessary.
+	 * Special Items: Images, overlays, sort.
+	 * 
+	 */
+	public static void Parse(Frame toParse, boolean firstParse) {
+		Parse(toParse, firstParse, false);
+	}
+
+	/**
+	 * 
+	 * @param toParse
+	 * @param firstParse
+	 * @param ignoreAnnotations
+	 *            used to prevent infinate loops such as when performing TDFC with
+	 *            an ao tag linked to a frame with an frameImage of a frame which
+	 *            also has an ao tag on it.
+	 */	
+	public static void Parse(Frame toParse, boolean firstParse, boolean ignoreAnnotations) { 
+		List<String> accessList = Label.getAccessibleLabelsNames(new ItemsList(toParse.getPrimaryBody()));
+		
+		ItemsList primaries = toParse.getPrimaryBody();
+		ItemsList surrogates = toParse.getSurrogateBody();
+		
+		transformOutOfPlaceItems(toParse, primaries);
+		transformOutOfPlaceItems(toParse, surrogates);
+		
+		toParse.getInteractableItems().clear();
+		List<Item> newBody = parseFromPrimary(primaries, accessList);
+		toParse.getBody().clear();
+		toParse.getBody().addAll(newBody);
+		generatingSupportingItems(toParse, toParse.getBody(), ignoreAnnotations);
+		
+		if (firstParse) {
+			ItemUtils.EnclosedCheck(toParse.getSortedItems());
+		}
+	}
+
+	private static List<Item> parseFromPrimary(ItemsList primaryBody, List<String> access) {
+		List<Item> parsedBody = new ArrayList<Item>();
+		
+		for (Item item: primaryBody) {
+			String encryptionLabel = item.getEncryptionLabel();
+			if (encryptionLabel == null || encryptionLabel.isEmpty()) {
+				parsedBody.add(item);
+			} else if (access.contains(encryptionLabel)) {
+				parsedBody.add(item);
+			} else {
+				parsedBody.addAll(item.getSurrogates());
+			}
+		}
+		
+		return parsedBody;
 	}
 
@@ -1225,5 +1274,5 @@
 				if (LastEdited.contains(x, y) && !FreeItems.getInstance().contains(LastEdited)
 						&& LastEdited.getParent() == DisplayController.getCurrentFrame()
-						&& LastEdited.getParent().getItems().contains(LastEdited)) {
+						&& LastEdited.getParent().getSortedItems().contains(LastEdited)) {
 					LastEdited.setOverlayPermission(UserAppliedPermission.full);
 					return LastEdited;
@@ -1412,5 +1461,5 @@
 			return null;
 		}
-		List<Item> items = current.getItems();
+		List<Item> items = current.getSortedItems();
 
 		// Remove all items that are connected to freeItems
@@ -1572,5 +1621,5 @@
 			MessageBay.suppressMessages(true);
 			int lastNumber = FrameIO.getLastNumber(defaultFrame.getFramesetName());
-			for (int i = 1; i <= lastNumber; i++) {
+			for (int i = 1; i <= lastNumber; i++) {				
 				// Load in next default, if it doesn't exist continue loop.
 				defaultFrame = FrameIO.LoadFrame(defaultFrame.getFramesetName() + i);
@@ -1670,5 +1719,5 @@
 						Frame indexFrame = FrameIO.LoadFrame(framesetName + '1');
 						// Look through the folder for help index pages
-						if (indexFrame != null && ItemUtils.FindTag(indexFrame.getItems(), "@HelpIndex") != null) {
+						if (indexFrame != null && ItemUtils.FindTag(indexFrame.getSortedItems(), "@HelpIndex") != null) {
 							// yPos += spacing;
 							yPos += 30;
Index: trunk/src/org/expeditee/gui/ItemsList.java
===================================================================
--- trunk/src/org/expeditee/gui/ItemsList.java	(revision 1415)
+++ trunk/src/org/expeditee/gui/ItemsList.java	(revision 1415)
@@ -0,0 +1,100 @@
+package org.expeditee.gui;
+
+import java.util.ArrayList;
+import java.util.Collection;
+import java.util.Collections;
+import java.util.Iterator;
+import java.util.List;
+import java.util.function.Predicate;
+
+import org.expeditee.items.Item;
+
+/**
+ * Extends a ArrayList of Items through composition in order to keep it sorted.
+ */
+public class ItemsList implements Iterable<Item> {
+	private List<Item> items = new ArrayList<Item>();
+	private boolean sorted = true;
+	
+	public ItemsList() { }
+	
+	public ItemsList(ItemsList initialList) {
+		items.addAll(initialList.items);
+	}
+	
+	public ItemsList(Collection<Item> unsorted) {
+		items.addAll(unsorted);
+		sort();
+	}
+	
+	public void add(Item item) {
+		items.add(item);
+		sorted = false;
+	}
+	
+	public void addAll(Collection<Item> toAdd) {
+		items.addAll(toAdd);
+	}
+	
+	public void sort() {
+		if (!sorted) {
+			items.removeIf(item -> item == null);
+		}
+		Collections.sort(items);
+		sorted = true;
+	}
+
+	@Override
+	public Iterator<Item> iterator() {
+		//sort();
+		return items.iterator();
+	}
+	
+	public boolean contains(Item item) {
+		return items.contains(item);
+	}
+	
+	public int size() {
+		return items.size();
+	}
+	
+	public void invalidateSorted() {
+		sorted = false;
+	}
+	
+	public boolean remove(Item item) {
+		return items.remove(item);
+	}
+	
+	public void removeAll(ItemsList newBody) {
+		items.removeAll(newBody.items);
+	}
+	
+	public void retainHistory(ItemsList historyItems) {
+		items.retainAll(historyItems.items);
+	}
+	
+	public int indexOf(Item item) {
+		return items.indexOf(item);
+	}
+	
+	public void set(int index, Item item) {
+		items.set(index, item);
+	}
+
+	public boolean removeIf(Predicate<Item> condition) {
+		return items.removeIf(condition);
+	}	
+	
+	public Collection<Item> underlying() {
+		return items;
+	}
+	
+	public boolean isEmpty() { 
+		return items.isEmpty();
+	}
+
+	public void clear() {
+		items.clear();
+	}
+}
Index: trunk/src/org/expeditee/gui/MessageBay.java
===================================================================
--- trunk/src/org/expeditee/gui/MessageBay.java	(revision 1414)
+++ trunk/src/org/expeditee/gui/MessageBay.java	(revision 1415)
@@ -279,6 +279,21 @@
 
 		if (!displayAlways && message.equals(_lastMessage)) {
+			Item lastMessage = _messages.get(_messages.size() - 1);
+			String text = lastMessage.getText();
+			if (text.endsWith("}")) {
+				int startOfRepeat = text.lastIndexOf("{");
+				String repeatString = text.substring(startOfRepeat);
+				repeatString = repeatString.substring(1, repeatString.length() - 1);
+				try {
+					int repeatCount = Integer.parseInt(repeatString) + 1;
+					text = text.substring(0, startOfRepeat).trim() + " {" + repeatCount + "}";
+				} catch (NumberFormatException e) {
+					e.printStackTrace();
+				}
+			} else {
+				text = text.trim() + " {2}";
+			}
+			lastMessage.setText(text);
 			DisplayController.DisableMailMode();
-			Misc.beep();
 			return null;
 		}
Index: trunk/src/org/expeditee/gui/Vector.java
===================================================================
--- trunk/src/org/expeditee/gui/Vector.java	(revision 1414)
+++ trunk/src/org/expeditee/gui/Vector.java	(revision 1415)
@@ -28,5 +28,8 @@
 
 /**
- * TODO: Explain WTF this is. cts16
+ * A vector is a type of overlay with additional features:
+ * 	- a location (origin)
+ *  - size (scaled from frame)
+ *  - etc
  */
 public class Vector extends Overlay {
Index: trunk/src/org/expeditee/io/Conversion.java
===================================================================
--- trunk/src/org/expeditee/io/Conversion.java	(revision 1414)
+++ trunk/src/org/expeditee/io/Conversion.java	(revision 1415)
@@ -691,13 +691,32 @@
 			return getExpediteeColorCode((Colour) output);
 
-		// covert points
+		// convert points
 		if (output instanceof Point)
 			return ((Point) output).getX() + " " + ((Point) output).getY();
 
-		if (output instanceof Boolean)
-			if ((Boolean) output)
-				return null;
-			else
-				return "F";
+		if (output instanceof Boolean) {
+			try {
+				Class<?> parentClass = method.getDeclaringClass();
+				Field defaultValueField = parentClass.getField(method.getName() + "Default");
+				boolean defaultValue = defaultValueField.getBoolean(null);
+				if (defaultValue == (boolean) output) {
+					return null;
+				}
+			} catch (IllegalArgumentException e) {
+				e.printStackTrace();
+			} catch (SecurityException e) {
+				e.printStackTrace();
+			} catch (NoSuchFieldException e) {
+				// true is the default for boolean values when no other default is provided
+				if ((boolean) output) {
+					return null;
+				} else {
+					return "F";
+				}
+			} catch (IllegalAccessException e) {
+				e.printStackTrace();
+			}
+			return output;
+		}
 
 		if (output instanceof int[]) {
Index: trunk/src/org/expeditee/io/DefaultFrameReader.java
===================================================================
--- trunk/src/org/expeditee/io/DefaultFrameReader.java	(revision 1414)
+++ trunk/src/org/expeditee/io/DefaultFrameReader.java	(revision 1415)
@@ -181,9 +181,10 @@
 			_DelayedItemTags.add('/');
 			
-			_ItemTagsExt.put(DefaultFrameWriter.ENCRYPTION_LABEL_STR, Item.class.getMethod("setEncryptionLabel", pString));
+			_ItemTagsExt.put(DefaultFrameWriter.ENCRYPTION_LABEL_STR, Item.class.getMethod("setEncryptionLabelOnLoad", pString));
 			
 			_ItemTagsExt.put(DefaultFrameWriter.PLACEHOLDER_STR, Text.class.getMethod("setPlaceholder", pString));
 			_ItemTagsExt.put(DefaultFrameWriter.SINGLE_LINE_ONLY_STR, Text.class.getMethod("setSingleLineOnly", pBool));
 			_ItemTagsExt.put(DefaultFrameWriter.TAB_INDEX_STR, Text.class.getMethod("setTabIndex", pInt));
+			_ItemTagsExt.put(DefaultFrameWriter.ACCEPTS_ENTER, Item.class.getMethod("setAcceptsEnter", pBool));
 		} catch (Exception e) {
 			e.printStackTrace();
Index: trunk/src/org/expeditee/io/DefaultFrameWriter.java
===================================================================
--- trunk/src/org/expeditee/io/DefaultFrameWriter.java	(revision 1414)
+++ trunk/src/org/expeditee/io/DefaultFrameWriter.java	(revision 1415)
@@ -99,4 +99,5 @@
 	public static final String PLACEHOLDER_STR = "_ph";
 	public static final String ENCRYPTION_LABEL_STR = "_el";
+	public static final String ACCEPTS_ENTER = "_ae";
 	public static final String MAGNETIZED_ITEM_BOTTOM_STR = MAGNETIZED_ITEM_BOTTOM + "";
 	public static final String MAGNETIZED_ITEM_TOP_STR = MAGNETIZED_ITEM_TOP + "";
@@ -263,4 +264,5 @@
 			_ItemTagsExt.put(DefaultFrameWriter.SINGLE_LINE_ONLY_STR, Text.class.getMethod("isSingleLineOnly"));
 			_ItemTagsExt.put(DefaultFrameWriter.TAB_INDEX_STR, Text.class.getMethod("getTabIndex"));
+			_ItemTagsExt.put(DefaultFrameWriter.ACCEPTS_ENTER, Item.class.getMethod("acceptsKeyboardEnter"));
 		} catch (Exception e) {
 			e.printStackTrace();
@@ -308,5 +310,5 @@
 				this.writeAnnotationTitle(starting.getTitleItem());
 			else
-				this.writeTitle(starting.getTitleItem(), starting.getItems());
+				this.writeTitle(starting.getTitleItem(), starting.getSortedItems());
 		}
 	}
Index: trunk/src/org/expeditee/io/DefaultTreeWriter.java
===================================================================
--- trunk/src/org/expeditee/io/DefaultTreeWriter.java	(revision 1414)
+++ trunk/src/org/expeditee/io/DefaultTreeWriter.java	(revision 1415)
@@ -88,5 +88,5 @@
 	protected List<Item> getSortedItems(Frame frame) 
 	{
-		List<Item> items = frame.getItems();
+		List<Item> items = frame.getSortedItems();
 		return items;
 	}
